diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/send.c ircd-hybrid-6.0/src/send.c
--- ircd-hybrid-6.0.orig/src/send.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/send.c	Wed Jun 20 02:32:06 2001
@@ -52,7 +52,7 @@
 
 static  void vsendto_prefix_one(register aClient *, register aClient *, const char *, va_list);
 static  void vsendto_one(aClient *, const char *, va_list);
-static  void vsendto_realops(const char *, va_list);
+static  void vsendto_ops_flag_butone(aClient*, int, const char *, va_list);
 
 static  unsigned long sentalong[MAXCONNECTIONS];
 static unsigned long current_serial=0L;
@@ -86,7 +86,7 @@
   DBufClear(&to->recvQ);
   DBufClear(&to->sendQ);
   if (!IsPerson(to) && !IsUnknown(to) && !(to->flags & FLAGS_CLOSING))
-    sendto_realops(notice, get_client_name(to, MASK_IP));
+    sendto_ops_flag(UMODE_SERVNOTICE, notice, get_client_name(to, MASK_IP));
   
   Debug((DEBUG_ERROR, notice, get_client_name(to, MASK_IP)));
 
@@ -142,7 +142,8 @@
 
         if (IsMe(to))
         {
-                sendto_realops("Trying to send to myself! [%s]", msg);
+                sendto_ops_flag(UMODE_DEBUG, "Trying to send to myself! [%s]", msg);
+		log(L_ERROR, "Trying to send to myself! [%s]", msg);
                 return 0;
         }
 
@@ -155,7 +156,7 @@
         if (DBufLength(&to->sendQ) > get_sendq(to))
         {
                 if (IsServer(to))
-                        sendto_realops("Max SendQ limit exceeded for %s: %d > %d",
+                        sendto_ops_flag(UMODE_SERVNOTICE, "Max SendQ limit exceeded for %s: %d > %d",
                                 get_client_name(to, FALSE),
                                 DBufLength(&to->sendQ), get_sendq(to));
 
@@ -241,7 +242,8 @@
 
         if (IsMe(to))
         {
-                sendto_realops("Trying to send to myself! [%s]", msg);
+                sendto_ops_flag(UMODE_DEBUG, "Trying to send to myself! [%s]", msg);
+		log(L_ERROR, "Trying to send to myself! [%s]", msg);
                 return 0;
         }
 
@@ -265,12 +267,12 @@
                 */
                 if (DBufLength(&to->sendQ) > get_sendq(to))
                 {
-                        sendto_ops_butone(to,
-                                "Max SendQ limit exceeded for %s : %d > %d",
-                                get_client_name(to, FALSE),
-                                DBufLength(&to->sendQ), get_sendq(to));
-
-                                return dead_link(to, "Max Sendq exceeded");
+		  sendto_ops_flag_butone(to, UMODE_SERVNOTICE, 
+					 "Max SendQ limit exceeded for %s : %d > %d",
+					 get_client_name(to, FALSE),
+					 DBufLength(&to->sendQ), get_sendq(to));
+		  
+		  return dead_link(to, "Max Sendq exceeded");
                 }
                 else
                 {
@@ -450,7 +452,8 @@
     }
   else if (IsMe(to))
     {
-      sendto_realops("Trying to send [%s] to myself!", sendbuf);
+      sendto_ops_flag(UMODE_DEBUG, "Trying to send to myself! [%s]", sendbuf);
+      log(L_ERROR, "Trying to send to myself! [%s]", sendbuf);
       return;
     }
 
@@ -765,7 +768,7 @@
 /*
  * sendto_channel_chanops_butserv
  *
- * Send a message to all members of a channel that are connected to this
+ * Send a message to all ops of a channel that are connected to this
  * server.
  */
 
@@ -790,10 +793,11 @@
   
   va_end(args);
 } /* sendto_channel_butserv() */
+
 /*
- * sendto_channel_chanops_butserv
+ * sendto_channel_non_chanops_butserv
  *
- * Send a message to all members of a channel that are connected to this
+ * Send a message to all non-ops of a channel that are connected to this
  * server.
  */
 
@@ -959,132 +963,6 @@
 } /* sendto_match_butone() */
 
 /*
- * sendto_ops_flags
- *
- *    Send to *local* ops only at a certain level...
- */
-
-void
-sendto_ops_flag(int flag, const char *pattern, ...)
-
-{
-  va_list args;
-  register aClient *cptr;
-  char nbuf[1024];
-
-  va_start(args, pattern);
-
-  if((flag == UMODE_SKILL) || (flag == UMODE_SERVNOTICE))
-    {
-      for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
-        {
-          if(TestBit(cptr->umodes,flag))
-            {
-              (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                               me.name, cptr->name);
-      
-              (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-      
-              vsendto_one(cptr, nbuf, args);
-            }
-        } /* for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client) */
-    }
-  else
-    {
-      for(cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
-        {
-          if(TestBit(cptr->umodes,flag))
-            {
-              (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                               me.name, cptr->name);
-              
-              (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-              
-              vsendto_one(cptr, nbuf, args);
-            }
-        } /* for(cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client) */
-    }
-  va_end(args);
-}  /* sendto_ops_flags */
-
-/*
- * sendto_ops
- *
- *      Send to *local* ops only.
- */
-
-void
-sendto_ops(const char *pattern, ...)
-
-{
-  va_list args;
-  register aClient *cptr;
-  char nbuf[1024];
-
-  va_start(args, pattern);
-  
-  for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
-    {
-      if (SendServNotice(cptr))
-        {
-          (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                           me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-          
-          vsendto_one(cptr, nbuf, args);
-        }
-    }
-
-  va_end(args);
-} /* sendto_ops() */
-
-
-/*
-** sendto_ops_butone
-**      Send message to all operators.
-** one - client not to send message to
-** from- client which message is from *NEVER* NULL!!
-*/
-
-void
-sendto_ops_butone(aClient *one, aClient *from, const char *pattern, ...)
-
-{
-  va_list args;
-  register int index;
-  register aClient *cptr;
-
-  va_start(args, pattern);
-
-  ++current_serial;
-
-  for (cptr = GlobalClientList; cptr; cptr = cptr->next)
-    {
-      if (!SendWallops(cptr))
-        continue;
-
-/* we want wallops
-   if (MyClient(cptr) && !(IsServer(from) || IsMe(from)))
-   continue;
-*/
-
-      index = cptr->from->fd; /* find connection oper is on */
-
-      if (sentalong[index] == current_serial)
-        continue;
-      
-      if (cptr->from == one)
-        continue;       /* ...was the one I should skip */
-      
-      sentalong[index] = current_serial;
-      
-      vsendto_prefix_one(cptr->from, from, pattern, args);
-    }
-
-  va_end(args);
-} /* sendto_ops_butone() */
-
-/*
 ** sendto_wallops_butone
 **      Send message to all operators.
 ** one - client not to send message to
@@ -1224,13 +1102,13 @@
         {
           vsprintf_irc(sendbuf, pattern, args);
           
-          sendto_realops(
+          sendto_ops_flag(UMODE_SERVNOTICE,
                      "Send message (%s) to %s[%s] dropped from %s(Fake Dir)",
                      sendbuf, to->name, to->from->name, from->name);
           return;
         }
 
-      sendto_realops("Ghosted: %s[%s@%s] from %s[%s@%s] (%s)",
+      sendto_ops_flag(UMODE_SERVNOTICE, "Ghosted: %s[%s@%s] from %s[%s@%s] (%s)",
                  to->name, to->username, to->host,
                  from->name, from->username, from->host,
                  to->from->name);
@@ -1300,120 +1178,6 @@
 } /* vsendto_prefix_one() */
 
 /*
- * sendto_realops
- *
- *    Send to *local* ops only but NOT +s nonopers.
- */
-
-void
-sendto_realops(const char *pattern, ...)
-
-{
-  va_list args;
-
-  va_start(args, pattern);
-
-  vsendto_realops(pattern, args);
-
-  va_end(args);
-} /* sendto_realops() */
-
-/*
-vsendto_realops()
- Send the given string to local operators (not +s)
-*/
-
-static void
-vsendto_realops(const char *pattern, va_list args)
-
-{
-  register aClient *cptr;
-  char nbuf[1024];
-  
-  for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
-    {
-      if (SendServNotice(cptr))
-        {
-          (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                           me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-          
-          vsendto_one(cptr, nbuf, args);
-        }
-    }
-} /* vsendto_realops() */
-
-/*
- * sendto_realops_flags
- *
- *    Send to *local* ops with matching flags
- */
-
-void
-sendto_realops_flag(int flag, const char *pattern, ...)
-
-{
-  va_list args;
-  register aClient *cptr;
-  char nbuf[1024];
-
-  va_start(args, pattern);
-
-  for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
-    {
-      if(TestBit(cptr->umodes,flag))
-        {
-          (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                           me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-          
-          vsendto_one(cptr, nbuf, args);
-        }
-    } /* for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client) */
-
-  va_end(args);
-} /* sendto_realops_flags() */
-
-/*
- * sendto_realops_flags
- *
- *    Send to *local* ops with *all* matching flags (UMODE_INVALID terminated list)
- *
- * Warning: this is expensive to process. Use it carefully.
- */
-
-void
-sendto_realops_flags(int* flag, const char *pattern, ...)
-
-{
-  va_list args;
-  register aClient *cptr;
-  char nbuf[1024];
-  int* f;
-  int send;
-
-  va_start(args, pattern);
-
-  for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
-    {
-      send = 1;
-      for (f = flag; *f != UMODE_INVALID; f++)
-	if (!TestBit(cptr->umodes,*f))
-	  send = 0;
-      if(send)
-        {
-          (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                           me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-          
-          vsendto_one(cptr, nbuf, args);
-        }
-    } /* for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client) */
-
-  va_end(args);
-} /* sendto_realops_flags() */
-
-/*
 ** ts_warn
 **      Call sendto_ops, with some flood checking (at most 5 warnings
 **      every 5 seconds)
@@ -1453,7 +1217,7 @@
       warnings = 0;
     }
 
-  vsendto_realops(pattern, args);
+  vsendto_ops_flag_butone(NULL, UMODE_SERVNOTICE, pattern, args);
   vsprintf(buf, pattern, args);
   log(L_CRIT, "%s", buf);
 
@@ -1527,21 +1291,48 @@
 #endif /* SLAVE_SERVERS */
 
 /*
- * sendto_ops_flags_butone
+ * sendto_ops_flag_butone
  *
- *    Send to *global* ops only at a certain level...
+ *    Send to any client with the given umode
  */
 
 void
+sendto_ops_flag(int flag, const char *pattern, ...)
+
+{
+  va_list args;
+
+  va_start(args, pattern);
+
+  vsendto_ops_flag_butone(NULL, flag, pattern, args);
+
+  va_end(args);
+}
+
+void
 sendto_ops_flag_butone(aClient *one, int flag, const char *pattern, ...)
 
 {
   va_list args;
-  register aClient *cptr;
-  char nbuf[1024];
 
   va_start(args, pattern);
 
+  vsendto_ops_flag_butone(one, flag, pattern, args);
+
+  va_end(args);
+}
+
+/*
+vsendto_ops_flag_butone()
+ Send the given string to all clients with the given flag, excluding the given server connection
+*/
+
+static void
+vsendto_ops_flag_butone(aClient *one, int flag, const char *pattern, va_list args)
+{
+  register aClient *cptr;
+  char nbuf[1024];
+  
   for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
     {
       if (IsPerson(cptr) && TestBit(cptr->umodes,flag))
@@ -1561,6 +1352,72 @@
 	continue;
       vsendto_one(cptr, nbuf, args);
     }
+} /* vsendto_realops() */
+
+/* This one is used in the magic WALLOPS hack to propogate server notices */
+
+void
+sendto_ops_flag_butone_from(aClient *one, int flag, aClient* from, const char *pattern, ...)
+{
+  register aClient *cptr;
+  char nbuf[1024];
+  va_list args;
+
+  va_start(args, pattern);
+
+  for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
+    {
+      if (IsPerson(cptr) && TestBit(cptr->umodes,flag))
+	{
+	  (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
+			   from->name, cptr->name);
+	  (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+	  vsendto_one(cptr, nbuf, args);
+	}
+    }
+  (void)ircsprintf(nbuf, ":%s WALLOPS %i :",
+		   from->name, flag);
+  (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+  for(cptr = serv_cptr_list; cptr; cptr = cptr->next_server_client)
+    {
+      if (IsMe(cptr) || (one && (cptr == one->from)))
+	continue;
+      vsendto_one(cptr, nbuf, args);
+    }
+
   va_end(args);
 }
 
+/* This one is used to propogate without giving away the source (so protecting routing information) */
+
+void
+sendto_ops_flag_butone_hidefrom(aClient *one, int flag, const char *pattern, ...)
+{
+  register aClient *cptr;
+  char nbuf[1024];
+  va_list args;
+
+  va_start(args, pattern);
+
+  for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
+    {
+      if (IsPerson(cptr) && TestBit(cptr->umodes,flag))
+	{
+	  (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
+			   me.name, cptr->name);
+	  (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+	  vsendto_one(cptr, nbuf, args);
+	}
+    }
+  (void)ircsprintf(nbuf, ":%s WALLOPS *%i :",
+		   me.name, flag);
+  (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+  for(cptr = serv_cptr_list; cptr; cptr = cptr->next_server_client)
+    {
+      if (IsMe(cptr) || (one && (cptr == one->from)))
+	continue;
+      vsendto_one(cptr, nbuf, args);
+    }
+
+  va_end(args);
+}
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/version.c.SH ircd-hybrid-6.0/src/version.c.SH
--- ircd-hybrid-6.0.orig/src/version.c.SH	Sat Oct 21 07:36:15 2000
+++ ircd-hybrid-6.0/src/version.c.SH	Tue Jun 19 04:39:41 2001
@@ -119,6 +119,11 @@
   "their advice, opinions, and code to IRC.",
   "Thanks also to those who provide the kind sys admins who let me and",
   "others continue to develop IRC.",
+  "-------------------------------------------------------------------",
+  "The dancer-hybrid conversion has been arranged, orchestrated, and",
+  "generally slaughtered by the following nefarious individuals:",
+  "",
+  "Comments and bug reports to opn-coders@vc.bc.ca",
   "",
   0,
 };
